unit Chwalpmf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, INIFiles, Buttons, FileCtrl, ExtCtrls,
  
  ChWalpDivers;

type
  TChwalpMainForm = class(TForm)
    EditChoisiBMP: TEdit;
    LblPPeintActuel: TLabel;
    BBtnSelectBMP: TBitBtn;
    BBtnSelectRep: TBitBtn;
    SelectRepDialog: TOpenDialog;
    SelectBMPDialog: TOpenDialog;
    FichListeBox: TFileListBox;
    Label1: TLabel;
    DirListeBox: TListBox;
    Label2: TLabel;
    BBtnOptions: TBitBtn;
    BBtnNoWalp: TBitBtn;
    BBtnHasard: TBitBtn;
    BBtnApropos: TBitBtn;

    ChangeTimer: TTimer;
    GeleChBox: TCheckBox;
    procedure BBtnSelectBMPClick(Sender: TObject);
    procedure EditChoisiBMPKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure BBtnSelectRepClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DirListeBoxClick(Sender: TObject);
    procedure FichListeBoxDblClick(Sender: TObject);
    procedure BBtnNoWalpClick(Sender: TObject);
    procedure BBtnHasardClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BBtnAproposClick(Sender: TObject);
    procedure BBtnOptionsClick(Sender: TObject);
    procedure ChangeTimerTimer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FichListeBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DirListeBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  protected
    procedure CMWininiChange (var Msg : TMessage) ;
              message CM_WININICHANGE;
    procedure WMDropFiles (var Msg : TMessage);
              message WM_DROPFILES ;
    procedure WinMsg  (var Msg : TMsg; var Handled : Boolean)  ;
    procedure GereDrop (hDrop : THandle) ;

  private
    { Private-dclarations }
    INIObj : TINIFile ;

    ActiveBMPPath : string ;
    FActiveBMP : string ;
    aucun : Boolean ;

    procedure SetActiveBMP (UnBMP : String) ;

  public
    { Public-dclarations }
    InitRep : string ;
    DATFile : string ;

    { compteur pour auto }
    mnpassees : integer ; { minutes coules depuis le dernier changement}

    NbBMPs : array [0..1000] of cardinal ;
    NbTotBMPs : integer ; {le sombre toatle de BMP rpertori (la mise  jour n'a lieu
                           que lors d'une slection dudit BMP }

    function NouveauRepFromFich (const UnFichier : string) : integer ;
    function NouveauRep (const UnRep : string) : integer ;
    function VerifSelectRep (const num : integer) : Boolean;
    procedure SupprimeRep (const num : integer) ;
    procedure InitEtLitListerepertoires ;

    procedure SupprimeSelectedFich ;

    procedure VerifApresopt;
    procedure LitActiveWallpaper ;
    procedure NoWallpaper ;
    function  ChangeWallpaper (const TheBMP : string) : Boolean;
                             { vrifie et charge le BMP }
    procedure MinimiseFenetre ;

    property  ActiveBMP : String read FActiveBMP write SetActiveBMP ;

  end;

var
  ChwalpMainForm: TChwalpMainForm;
  bidon : integer ;

{************************************************************************}

implementation

uses ShellAPI,
     Utils_Listes, Utils_Dialogs, Utils_Strings, Utils_Files, Maths,
     OuvrFich, ChwalpAboutBox, ChwalpOptions ;

{$R *.DFM}

procedure TChwalpMainForm.FormCreate(Sender: TObject);
begin
  Mode := mChargement ;

  { la barre de titre }
  Caption := Chwalpname ;

  { initialisation des fichiers }
  InitRep := ExtractFilePath (Application.ExeName); {localisation de l'EXE }

  DATFile := InitRep+'CHWALP.DAT';

 { init de FichListBox }
  FichListeBox.Directory := '';

  { penser aux fichiers cachs }
  { et aux autres images que BMP }

  { init de  EditChoisBMP }
  EditChoisiBMP.Text := '???.BMP';

  { la liste des rpertoires utiliss}
  InitEtLitListerepertoires ;
  LitActiveWallpaper ; { affecte le bmp, et les champs adquats }

  {  ce stade, le rpertoire et le BMp courants ont t slectionns }

  { drag & drop }
  DragAcceptFiles (Handle, True);
  DragAcceptFiles (Application.Handle, True);
  Application.OnMessage := WinMsg ;

  { tps ecoule }
  mnpassees := 0 ;

  Mode := mEnAttente ;

end;

procedure TChwalpMainForm.FormDestroy(Sender: TObject);
var i : integer ;
begin
  { fin du drag & drop           }
  DragAcceptFiles (Handle, False);
  DragAcceptFiles (Application.Handle, False);

  { stocke la liste des rpertoires }
  DirListeBox.Visible:=False;
  DirListeBox.Sorted:=False;
  for i:=0 to DirListeBox.Items.Count-1 do begin
    DirListeBox.Items.Add (IntToStr(NbBMPs[i]));
  end ;
  DirListeBox.Items.SaveToFile(DATFile) ;
end;

procedure TChwalpMainForm.InitEtLitListerepertoires ;
  var i, NbRep : integer ;
  begin
    { lecture dans le Chwalp.dat }
    if FileExists (DATFile) then begin
      {stocke la liste des fichiers et des nombres de BMPs }
      {inhibe le triage pour raisons pratiques et masque ce qui se passe}
      DirListeBox.Visible := False ;
      DirListeBox.Sorted:=False ;

      DirListeBox.Items.LoadFromFile (DATFile);
      {rcuprer les nombres de BMP en lisant le tableau par la fin }
      NbRep :=DirListeBox.Items.COunt div 2;
      for i:=0 to NbRep-1 do begin
        NbBMPs[NbRep-i-1]:=StrToInt(DirListeBox.Items.Strings[NbRep*2-i-1]);
        DirListeBox.Items.Delete(NbRep*2-i-1); {efface le chiffre qu'il vient de lire }
      end ;
      NbTotBMPs :=0;
      for i:=0 to NbRep do
        NbTotBMPs:=NbTotBMPS + NbBMPs[i];

      {remise en place vue et triage }
      DirListeBox.Sorted:=True ;
      DirListeBox.Visible :=True;

      if DirListeBox.items.Count>0 then begin
        { limination doubles}
        ElimineDuplicates(DirListeBox.Items, -1, False);
        { vrification prsence en balayant Itemindex, qui ne sera
        vraiment affect que par LitActiveWallpaper }
        with DirListeBox do begin
          DirListeBox.ItemIndex:=DirListeBox.Items.Count-1 ;
          repeat { pas de boucle normale, des chanes peuvent disparatre }
             { bidon := itemindex ;
              intbox ('itemindex ', bidon);
              yesbox('ch '+items.strings[bidon]);}
              if VerifSelectRep(ItemIndex) then{ si s'est bien pass, passer au suivant }
                ItemIndex := ItemIndex-1 ;
          until itemIndex <0 ;
        end ;
      end ;
    end ;
   { yesbox ('fin lecture');}
  end ;

procedure TChwalpMainForm.LitActiveWallpaper ;
  var OldMode : TMode;
  begin
      OldMode := Mode ;
      mode := mLitWinini ;
      INIObj := TIniFile.Create ('WIN.INI');
      ActiveBMP := INIObj.ReadString('Desktop', 'Wallpaper', '');
      INIObj.Free ;
      Mode := OldMode ;
  end ;

procedure TChwalpMainForm.CMWininiCHange ;
 { le BMP a chang :dterminer d'o a
 vient (prog mme ou extrieur) et agir en consquence }
  begin
    if Mode = mEnAttente then begin  { message extrieur }
      inherited ;
      LitActiveWallpaper ;
    end else if Mode = mOrdonneWlpChange then begin
      { retour de message : rien  faire }
      Mode := mEnAttente ;
    end ;
  end ;

procedure TChwalpMainForm.WMDropFiles ;
  var hDrop:THandle ;
  begin
     hDrop :=THandle (Msg.wParam);
     GereDrop (hdrop);
     msg.result :=  0;
  end ;

procedure TChwalpMainForm.WinMsg (var Msg : TMsg; var Handled : Boolean) ;
 { destine  traiter ce qui n'est pas TMessage, messages que
 delphi traite tout seul  (WM_dropfiles n'en est pas un }
  var hDrop : THandle ;
  begin
     if Msg.message = WM_DropFiles then begin
       Handled := True ;
       hDrop := THandle (Msg.wParam);
       GereDrop (hDrop);
     end ;
  end ;

procedure TChwalpMainForm.GereDrop (hDrop : THandle );
    var nbfich, i : integer ;
      chaine : string ;
      chaineAZT : PChar ;
      changeBMp : Boolean ;
  begin
   { s'enquiert du nombre de fichiers  effacer }
    nbfich := DragQueryFile (hDrop, $FFFF, nil, 0);
 { NB : le premier fichier est n 0, faire les boucles de 0  Nbfich }

     chaineAZT:=StrAlloc (300);
     changeBMP := False ;

     For i:=0 to nbfich-1 do begin
       DragQueryFile (hDrop, i, chaineAZT, 300 );
       chaine := StrPas (chaineAZT);
       chaine := ExpandFileName(chaine);
       if IsAFile(chaine) then begin  { si est un fichier, et existe }
         if (not changeBMP) then begin
          { le 1er fichier devient le Activebmp }
           ActiveBMP := chaine ;
           changeBMP := True ;
         end ;
       end else if RepExiste (chaine) then begin
         NouveauRep (chaine);
       end;
     end ;

   { Fin du glisser-dposer }
     DragFinish (hDrop);
  end;

function TChwalpMainForm.NouveauRepFromFich (const UnFichier : string ) : integer;
  var UnRep : string ;
  begin
    UnRep := ExtractFilePath (UnFichier);
    Result := NouveauRep (UnRep) ;
  end ;

function TChwalpMainForm.NouveauRep (const UnRep : string): integer ;
  var num, i, oldnbrep : integer ;
      ch : string ;
  begin
    if (UnRep='') or (UnRep=' ') then
      result := -1
    else begin
      { vrifier et stocker }
      ch := lowerCase(RepSansSlash(UnRep));
      { ajouter dans la liste des rpertoires }
      OldNbRep:= DirListeBox.items.Count; {pour comparaison ultrieure }
      num := AddListBoxEtElimineDuplicates(DirListeBox,ch, False);
      if num=-1 then StopBox ('Ppin : num = -1 dans NouveauRep'); { scurit }

      if OldNbRep<DirListeBox.Items.COunt then begin
        {c un nouveau rpertoire }
        for i:= DirListeBox.Items.COunt-1 downto num+1 do
          NbBMPs [i] := NbBMPs [i-1];
        NbBMPS [num] := 9999; {attendre + tard pour le stockage du nombre }
      end ;
      Result := num
    end ;
  end ;

function TChwalpMainForm.VerifSelectRep (const num : integer) : Boolean ;
 { renvoie True si le rpertoire est slectionn (ou du moins
 valide quand on charge les DAT du fichier d'initialisation }
  { n dans la liste de DirListeBox (0  count-1) }
var TheRep : string ;
begin
  if num>-1 then begin
    TheRep := RepSansSlash(DirListeBox.Items.Strings[num]) ;
   { vrifier l'existence du rpertoire }
    if (not RepExiste(TheRep)) then begin
      if Mode<>mChargement then
        ExclamBox ('Le rpertoire '+TheRep+' est introuvable');
      { le supprimer }
      {YesBox ('Je saque'+TheRep) ;}
      SupprimeRep (num);
      Result := False ;
    end else begin

      { le rpertoire est valide : afficher les fichiers et compter
       si on n'est pas   en chargement}
      Result := True ;
      if (Mode=mEnAttente) or (Mode=mLitWinini) then begin
        FichListeBox.Directory := TheRep ;
          { illuminer le rpertoire en cours }
        DirListeBox.ItemIndex :=
                         ChercheInStrings (DirListeBox.Items, TheRep, False) ;
        {le comptage }
        NbBMPs[DirListeBox.ItemIndex] := FichListeBox.Items.Count;
      end ;
    end ;
  end else
    Result := False ;
end ;

procedure TChwalpMainForm.SupprimeRep (const num : integer) ;
                                      { en numrotation  partir de 0 }
 { NB : ne slectionne pas le nouveau rpertoire (lectures de rpertoire
 parfois inutiles }
  var WasOnIt : Boolean;
      i : integer ;
  begin
    with DirListeBox do begin
      WasOnIt := (ItemIndex=num);
      Items.Delete (num);
      { itemindex passe  -1 aprs la suppression si il tait dessus }
      if WasOnIt then
        if num=DirListeBox.Items.Count then { cas o tait sur le dernier}
          ItemIndex := DirListeBox.Items.Count-1
        else
          ItemIndex := num ; { passe sur ligne suivante }
    end ;
    {mise  jour du compteur des BMPs}
    for i:= num to DirListeBox.Items.Count do
      NbBMPs[i]:=NbBMPs[i+1];
  end ;

procedure TChwalpMainForm.SupprimeSelectedFich;
  var ch : string ;
      chPC : PChar ;
      place : integer ;
  begin
  with FichListeBox do begin
    place := ItemIndex ;
    ch := ExpandFileName (Items.Strings[ItemIndex]);
    if YesNoBox ('Tenez-vous vraiment  effacer '+ch+' ?')=mrYes then begin
      chPC :=StrAlloc (500);
      StrPCopy (chPC, ch);
      DeleteFile (chPC) ;
      StrDispose(chPC);
      Items.Delete (ItemIndex);
      { nouvel index }
      if Items.Count>0 then
        if place=FichListeBox.Items.Count then { cas o tait sur le dernier}
          ItemIndex := Items.Count-1
        else
          ItemIndex := place ; { passe sur ligne suivante }
      { dans le cas o c'tait le papier peint }
      if LowerCase(ActiveBMP)=LowerCase(ch) then begin
        { slection du papier peint suivant }
        if (Items.Count>0) and (YesNoBox ('Changer le papier peint ?')=mrYes) then begin
          ActiveBMP := Items.Strings[ItemIndex];
        end else begin
          ActiveBMP := '';
          itemIndex := -1;
        end ;
      end ;
    end ;
  end ;
  end ;

procedure TChwalpMainForm.SetActiveBMP (UnBMP : string);
  { procdure destine  l'affectation du BMP ; vrifie des choses }
  var aucundemande : Boolean ;
            procedure MiseAJourChamps;
              var num, place : integer ;
                  ch : string ;
              begin
                if not aucun then begin
                  mnpassees := 0 ;
                  ActiveBMPPath := ExtractFilePath (FActiveBMP) ;
                  EditChoisiBMP.text := FActiveBMP ;
                  Self.Caption := ChwalpName+' : '+FActiveBMP ;
                  with DirListeBox do begin
                  { stocke ventuellemnt et slectionne }
                    place := NouveauRep (ActiveBMPPath);
                    VerifSelectRep(place) ;
                  end;
                  ch :=ExtractFichName(FActiveBMP);
                  FichListeBox.ItemIndex :=
                              ChercheInStrings(FichListeBox.Items, ch, False);
                end else begin
                  ActiveBMPPath:= '';
                  EditChoisiBMP.text := FActiveBMP ;
                  Self.Caption := ChwalpName ;
                  { rpertoire actif : le 1er (si y'en a un)}
                  num := Min(0, DirListeBox.Items.Count-1) ;
                  DirListeBox.ItemIndex := num ;
                  { lecture de ce rpertoire }
                  if num>=0 then
                    FichListeBox.Directory:=DirListeBox.Items.Strings[num]
                  else
                    FichListeBox.Clear;
                end ;
                { slection du rpertoire }
              end ;
  begin
    { si vient du winini, fichier ne doit pas tre cach }
    if Mode<>mLitWinini then
      aucun := not FichierExiste (ExpandFileName(UnBMP), OptBox.ChBCaches.Checked)
    else
      aucun := not FichierExiste (ExpandFileName(UnBMP), False);

    aucundemande := (lowercase(UnBMP)='');

    if Mode=mLitWinini then begin
      if not aucun then
        FActiveBMP := LowerCase(UnBMP)
      else
        FActiveBMP := '';

      MiseAJourChamps ;  { si dans le Win.ini, pas de vrification }

    end else begin
      { sinon y a test chargement du BMP}
      UnBMP := LowerCase (UnBMP);

     { vrification d'une extension valide }
      if (ExtractFileExt (UnBMP)='.') then begin
        UnBMP := UnBMP+'bmp';
      end ;
      if (ExtractFileext (UnBMP)='') then begin
        UnBMP := UnBMP+'.bmp';
      end ;

     { vrification de l'existence }
      if aucun then begin
        if (Mode=mEnAttente) and (not AucunDemande) then
          StopBox ('Le fichier '+ UnBMP+ ' est introuvable');

        NoWallpaper ;
        FActiveBMP := '';
        MiseAJourChamps ;
      end else begin
              { affectation et on voit si a a march }
          if ChangeWallpaper (UnBMP) then begin
            { le chargement est correct }
            FActiveBMP := UnBMP;
            MiseAJourChamps  ;
          end ;
      end ;
    end ;
  end ;

function TChwalpMainForm.ChangeWallpaper (const TheBMP : string) : Boolean;
  { chargement itself s 'un papier peint valide ;
    appel par ActiveBMP := quelque chose }
  { renvoie True si bien march }
  var chaineAZT : PChar ;
      loaded : boolean ;
  begin
    { changeemnt de mode pour les autres mthodes appels lors de
    l'mission du message Wininichange}
     Mode := mOrdonneWlpChange ;  {remodifi par LitActiveWallpaper
                      quand on y reviendra  cause du message Wininichange}

     chaineAZT := StrAlloc (260) ;
     { affectation itself }
       StrPCopy(chaineAZT, TheBMP);
       Loaded := SystemParametersInfo(spi_SetDeskWallpaper, 0, chaineAZT,
                      spif_UpdateIniFile or spif_SendWinInichange) ;
       StrDispose (chaineAZT) ;

   {Loaded est  true si tout s'est bien pass }
   if not Loaded then begin
     Mode := mEnattente ;
     StopBox ('Windows n''a pu charger '+ TheBMP+ '. Vrifiez la valdidit de ce papier peint')
   end ;

   ChangeWallpaper := Loaded ;

 end ;

procedure TChwalpMainForm.NoWallpaper ;
  { chargement itself s 'un papier peint valide ;
    appel par ActiveBMP := quelque chose }
  { renvoie True si bien march }
  var chaineAZT : PChar ;
  begin
    { changement de mode pour les autres mthodes appels lors de
    l'mission du message Wininichange}
     Mode := mOrdonneWlpChange ;  {remodifi par LitActiveWallpaper
                      quand on y reviendra  cause du message Wininichange}

     chaineAZT := StrAlloc (260) ;
     { affectation itself }
       StrPCopy(chaineAZT, '');
       SystemParametersInfo(spi_SetDeskWallpaper, 0, chaineAZT,
                      spif_UpdateIniFile or spif_SendWinInichange) ;
       StrDispose (chaineAZT) ;
  end ;

procedure TChwalpMainForm.BBtnSelectBMPClick(Sender: TObject);
  var FichChoisi : string ;
begin
  { demande la slection d'un BMP }
    SelectBMPDialog.Title := 'Slection d''une image';
    if SelectBMPDialog.Execute then begin
      FichChoisi := LowerCase(SelectBMPDialog.Files.Strings [0]) ;
      ActiveBMP  := FichChoisi ;
    end ;
end;

procedure TChwalpMainForm.BBtnSelectRepClick(Sender: TObject);
  begin
    with SelectrepDialog do begin
      Title:= 'Slection d''un rpertoire';
      FileName := 'papier.bmp';
      if Execute then begin
        VerifSelectRep(NouveauRepFromFich (Files.Strings[0]));
      end ;
    end ;
  end;

procedure TChwalpMainForm.EditChoisiBMPKeyPress(Sender: TObject;
  var Key: Char);
var Choisi : string ;
begin
  { ragit  l'entre d'un nom (via ENTER) }
  if Key=#13 then with EditChoisiBMP do begin
    Choisi := Lowercase(Text);
    ActiveBMP := Choisi;
  end ;

  if Key=#27 then
    MinimiseFenetre ;
end;


procedure TChwalpMainForm.DirListeBoxClick(Sender: TObject);
  begin
    { slectionner le rperoire adquat }
    VerifSelectRep (DirListeBox.ItemIndex);
  end;

procedure TChwalpMainForm.FichListeBoxDblClick(Sender: TObject);
  { double clic }
begin
  ActiveBMP := FichListeBox.FileName ;
end;

procedure TChwalpMainForm.DirListeBoxKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var num : integer ;
begin
  if not(ssShift in Shift) then case Key of

   46 : { touche Suppr} begin
      num := DirListeBox.ItemIndex;
      SupprimeRep (num);

      if num=DirListeBox.Items.count then { c'tait le dernier de la liste }
        if num>0 then
          VerifSelectRep (DirListeBox.Items.Count-1)
        else
          FichListeBox.Clear  { c'tait le dernier rpertoire de la liste }
      else
        VerifSelectRep (num);
    end ;

   ord ('h'), Ord('H') :
      begin with DirListeBox do begin
          If items.count>0 then begin
            VerifSelectRep (Random(Items.Count))
          end ;
        end ;
      end ;

  else
    { cas non trait : transmettre  la fiche }
    FormKeyDown (DirListeBox, Key, Shift);
  end
  else
    FormKeyDown (DirListeBox, Key, Shift);
end;

procedure TChwalpMainForm.FichListeBoxKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not(ssShift in Shift) then case Key of
     13 : { entre}  ActiveBMP := FichListeBox.FileName ;
     46 : { suppr }  SupprimeSelectedFich ;
     Ord('h'), Ord('H') : BBtnHasardClick (FichListeBox) ;
  else
   { cas non trait : transmettre  la fiche }
    FormKeyDown (FichListeBox, Key, Shift) ; { retransmet  la fiche }
  end else
    FormKeyDown (FichListeBox, Key, Shift) ; { retransmet  la fiche } 
end;

procedure TChwalpMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
     27 : { ESC }    MinimiseFenetre ;
     ord(' ') : BBtnNoWalpClick (fichListeBox) ;
     ord('h'), ord('H') : BBtnhasardClick (Self) ;
     ord('r'), ord ('R') : BBtnSelectRepClick (Self);
     ord('b'), ord ('B'), ord('p'), ord ('P') :
                                    BBtnSelectBMPClick (Self);
  end ;
end;

procedure TChwalpMainForm.BBtnNoWalpClick(Sender: TObject);
begin
  ActiveBMP := ''
end;

procedure TChwalpMainForm.BBtnHasardClick(Sender: TObject);
  { choix au hasard }
  var choix, rep : string ;
      averti : boolean ;
      i, n, stot : integer ;
      HHasardLieu : THasardLieu;
      HHasardTech : THasardtech ;
  label 900 ;

  procedure ChoisitPremierRep ;
   label 100 ;
   begin
     100 :
            if DirListeBox.Items.Count>0 then begin
              if VerifSelectRep(0) then
                rep := DirListeBox.Items.Strings [0]
              else
                goto 100
            end else begin
              if not averti then ExclamBox ('Pas de rpertoire utilisable !');
              averti := True ;
            end ;
   end ;

  procedure ChoisitRephasard ;
      label 200;
      begin
        200 :
            if DirListeBox.Items.Count>0 then begin
              n := random(DirListeBox.Items.count) ;
              if VerifSelectRep(n) then
                rep := DirListeBox.Items.Strings [n]
               else
                 goto 200 ;
            end else begin
              if not averti then ExclamBox ('Pas de rpertoire utilisable !');
              averti := True ;
            end ;
      end ;

   procedure ChoisitRepActif ;
   { et slectionne le premier si y en a pas }
   begin
          if DirListeBox.ItemIndex>-1 then
            rep := DirListeBox.Items.Strings [DirListeBox.ItemIndex]
          else begin{ rien de slectionn }
            ChoisitPremierRep ;
          end ;
   end ;

   procedure ChoisitRepSucc ;
   label 300 ;
   begin
          300 :
          if DirListeBox.ItemIndex>-1 then begin
            if DirListeBox.ItemIndex = DirListeBox.Items.Count-1 then
              DirListeBox.ItemIndex := -1 ;
            n :=DirListeBox.ItemIndex+1  ;
            rep := DirListeBox.Items.Strings [n] ;
            if not VerifSelectRep (n) then
              goto 300

          end else begin{ rien de slectionn }
            ChoisitPremierRep ;
          end ;
   end ;



  begin

    HHasardLieu := OptBox.OpHasardLieu ;
    HHasardTech := OptBox.OpHasardTech ;
    choix := 'Zut !'; {pour test final }
    rep:='';
    Randomize ;

    if Sender<>BBtnhasard then averti:=true else averti := False;
    { vite messages lors des changements auto }

    { cas du hasard global }
    if HHasardTech = htHasardGlobal then begin
      900 :
     { StopBox ('Hasard global pas encore implment');}
      repeat
        NbTotBMPs := 0;
        for i:=0 to DirListeBox.Items.Count-1 do
            NbTotBMPs := NbTotBMPs + Max(NbBMPs [i], 1);
       { IntBox ('nbtot', nbtotbmps);}
        {choix dans le tas }
        n := Random (Nbtotbmps);
       { intbox ('choix', n);}
        {slection : on compte jusqu' tomber sur le bon rpertoire }
        stot := 0;
        i:=0 ;
        repeat
          stot := stot+NbBMPs [i];
          Inc (i);
        until (stot>n) or (i>DirListeBox.Items.Count);
        if i>DirListeBox.Items.Count then i:=DirListeBox.Items.Count;
        Dec(i);
        stot :=stot-NbBMPs [i] ;
      until verifSelectRep(i);
      if FichListeBox.Items.Count>0 then begin
        n:=n-stot ;
        if n<0 then begin
          goto 900;
        end ;
        {intbox('n', n);}
        choix :=FichListeBox.Items.Strings[
                                 Min(FichlisteBox.Items.Count-1, n)]
      end ;
    end

    else
    {hasard hasard }
    if (HHasardTech=htHasardDsRep) and (HHasardLieu=hlRepHasard) then
      with FichListeBox do begin
        ChoisitRepHasard ;
        if Items.Count>0 then
          choix := ExpandFilename((Items.Strings[Random(Items.Count)]))
      end
    else
    { hasard rep sel }
    if (HHasardTech=htHasardDsRep) and (HHasardLieu=hlRepActif) then
      with FichListeBox do begin
        ChoisitRepActif ;
        if Items.Count>0 then
          choix := ExpandFilename((Items.Strings[Random(Items.Count)])) ;
      end
    else
    {hasard rep succ }
    if (HHasardTech=htHasardDsRep) and (HHasardLieu=hlRepSucc) then
      with FichListeBox do begin
        ChoisitRepSucc ;
        if Items.Count>0 then
          choix := ExpandFilename((Items.Strings[Random(Items.Count)])) ;
      end

    else
    {succ ds sel}
    if (HHasardTech=htSuccessif) and (HHasardLieu=hlRepActif) then
      { revenir au dbut de la liste quand liste finie, me pas changer le rpertoire}
      with FichListeBox do begin
        if Items.Count>0 then
          if ItemIndex=Items.Count-1 then
            choix := ExpandFilename((Items.Strings[0]))  {1er dans le rpertoire }
          else
            choix := ExpandFilename((Items.Strings[ItemIndex+1]))  {suivant }
      end

    else
    {succ ds succ & succ dans hasard}
    if (HHasardTech=htSuccessif) and ((HHasardLieu=hlRepSucc)or(HHasardLieu=hlRepHasard)) then
      { ne changer le rpertoire que si l'actuel est puis }
       with FichListeBox do begin
           if (ItemIndex=-1)or(ItemIndex=Items.Count-1)or(Items.Count=0) then begin
             if HHasardLieu=hlRepSucc then ChoisitRepSucc
                                      else ChoisitRepHasard ;
             if Items.Count>0 then
               choix := ExpandFilename((Items.Strings[0])) ; {1er dans le rpertoire }
           end else
             if Items.Count>0 then
               choix := ExpandFilename((Items.Strings[itemIndex+1])) ;
       end

     {plant...}
     else begin
          if not averti then YesBox ('Pas de papiers peints dans '+rep+' !');
          averti:=True;
     end  ;

    {affectation finale}

    if (choix='Zut !') and (not averti) then  {scurit }
      YesBox ('Pas de papier peint disponible dans le rpertoire !')
    else if choix<>'Zut !' then
      ActiveBMP := choix ;

  end;{ fin clickhasard}

procedure TChwalpMainForm.MinimiseFenetre ;
  begin
    Application.Minimize ;
  end ;

procedure TChwalpMainForm.BBtnAproposClick(Sender: TObject);
begin
  AboutBox.ShowModal
end;

procedure TChwalpMainForm.BBtnOptionsClick(Sender: TObject);
begin
  OptBox.ShowModal ;
  { mise en place venntuelle d'un changement auto }
  VerifApresopt ;
end;

procedure TChwalpMainForm.VerifApresOpt ;
{ vrifie pour Timer et les fichiers cachs }
begin
  if OptBox.ChBAuto.Checked then begin
    ChangeTimer.Enabled := True;
    GeleChBox.Enabled:= True;
    GeleChBox.Checked:= False;
    if OptBox.Delai>0 then
      ChangeTimer.interval := 60000  { ttes les minutes }
    else
      ChangeTimer.interval := 2000 ; { ttes les 2 secondes }
  end else begin
    ChangeTimer.Enabled := False ;
    GeleChBox.Checked:= False;
    GeleChBox.Enabled :=  False ;
  end ;

  if OptBox.ChBCaches.Checked then
    FichListeBox.FileType := FichListeBox.FileType+[ftHidden, ftSystem]
  else
    FichListeBox.FileType := FichListeBox.FileType-[ftHidden, ftSystem] ;
end ;

procedure TChwalpMainForm.ChangeTimerTimer(Sender: TObject);
begin
  if (not OptBox.Visible) and (not ABoutBox.Visible) and (not GeleChBox.Checked)then
  { il faut qu'aucune autre fiche ne soit active, et cran pas gel }
    if ChangeTimer.interval = 60000 then begin
      Inc (mnpassees);
     { IntBox('Delai', OptBox.Delai);
      IntBox('mnpassees', mnpassees);}
      if ((mnpassees>0) and (mnpassees mod OptBox.Delai = 0))
         or (mnpassees>optBox.Delai) then begin
        BBtnHasardClick (Self) ;
        { mnpassees : chang par SetActiveBMP }
      end else begin
{        Inc (mnpassees);
        YesBox('encore une minute de passe');}
      end ;
    end else begin
      BBtnhasardClick(Self);
    end ;
end;

procedure TChwalpMainForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  OptBox.SauveINI;
  if OptBox.ChBFinNone.Checked then begin
    BBtnNoWalpClick (Self);
    ActiveBMP:='';
    CanClose := True ;
  end else
    canClose := True ;
end;

end.
