unit Effbttn;

{ Composant TPushButton; TColorPushButton }

interface

uses StdCtrls, Classes ;

type
  TEffectType= (efStretch, efHorizStretch, efVertStretch) ;

  TEffectButton = class (TButton)
    private
      FEffect : TEffectType ;
      FEffectWait : LongInt ;
      FStretchSteps : Byte ;
      procedure SetEffect (Effect : TEffectType) ;
      procedure SetEffectWait (EffectWait : LongInt) ;
      procedure SetStretchSteps (Steps : Byte) ;
    public
      constructor Create (AOwner : TComponent) ; override ;
      procedure Click ; override ;
    published
      property Effect : TEffectType
        read FEffect  write SetEffect  default efStretch ;
      property EffectWait : LongInt
        read FEffectWait write SetEffectWait default 0 ;
      property StretchSteps : Byte
        read FStretchSteps  write SetStretchSteps  default 10 ;
    end ;



{** enregistrement ** }

procedure Register;

{*********************************************************************}
implementation

procedure TEffectButton.SetEffect (Effect : TEffectType) ;
  begin
    if FEffect<>Effect then
      FEffect := Effect ;
  end ;

procedure TEffectButton.SetEffectWait (EffectWait : LongInt) ;
  begin
    if EffectWait <>EffectWait then begin
      if EffectWait <0 then
        EffectWait := 0 ;
      if EffectWait >100000000 then
        EffectWait := 100000000 ;
      FEffectWait := EffectWait ;
    end ;
  end ;

procedure TEffectButton.SetStretchSteps (Steps : Byte) ;
  begin
    if FStretchSteps <> Steps then begin
      if Steps < 1 then
        Steps:=1;
      if Steps > 100 then
        Steps := 100 ;
      FStretchSteps := Steps ;
    end ;
  end;

constructor TEffectButton.Create (AOwner : TComponent) ;
  begin
    inherited Create (AOwner) ;
    FEffect := efStretch ;
    FEffectWait := 0 ;
    FStretchSteps := 10 ;
  end ;

procedure TEffectButton.Click ;
  var i1 : integer ;
      l1 : LongInt ;
  begin
    inherited Click ;
    case FEffect of
      efStretch  :
        if (Width>(FStretchSteps*2)) and (Height>(FStretchSteps*2)) then begin
          for i1 := 1 to FStretchSteps do begin
            SetBounds (Left+1, Top+1, Width-2, Height-2) ;
            Repaint ;
            if FEffectWait > 0 then
              for l1:=0 to FEffectWait do begin
                { boucle vide, ce qui est dbile}
              end ;
          end ;
          for i1:=1 to FStretchSteps do begin
            SetBounds (Left-1, Top-1, Width+2, Height+2) ;
            Repaint ;
            if FEffectWait>0 then
              for l1:=0 to FEffectWait do
                begin
                 { boucle vide, ce qui est con }
                end ;
          end ;
        end ;

      efHorizStretch :
        if (Width>(FStretchSteps*2)) then begin
          for i1 := 1 to FStretchSteps do begin
            SetBounds (Left+1, Top, Width-2, Height) ;
            Repaint ;
            if FEffectWait > 0 then
              for l1:=0 to FEffectWait do begin
                { boucle vide, ce qui est dbile}
              end ;
          end ;
          for i1:=1 to FStretchSteps do begin
            SetBounds (Left-1, Top, Width+2, Height) ;
            Repaint ;
            if FEffectWait>0 then
              for l1:=0 to FEffectWait do
                begin
                 { boucle vide, ce qui est con }
                end ;
          end ;
        end ;

      efVertStretch :
        if (Height>(FStretchSteps*2)) then begin
          for i1 := 1 to FStretchSteps do begin
            SetBounds (Left, Top+1, Width, Height-2) ;
            Repaint ;
            if FEffectWait > 0 then
              for l1:=0 to FEffectWait do begin
                { boucle vide, ce qui est dbile}
              end ;
          end ;
          for i1:=1 to FStretchSteps do begin
            SetBounds (Left, Top-1, Width, Height+2) ;
            Repaint ;
            if FEffectWait>0 then
              for l1:=0 to FEffectWait do
                begin
                 { boucle vide, ce qui est con }
                end ;
          end ;
        end ;
    end ;
  end ;

procedure Register;
begin
  { Recensement des nouveaux composants }
  RegisterComponents('Exemples', [TEffectButton]);
end;


{***********************************************************}

begin
  { Recensement des nouvelles classes }
  RegisterClasses([TEffectButton]);
end.

