{ EFFECTS.PAS }

{ Effects - une unit d'effets }

{ Copyright (c) 1995 by Arthur Burda }

unit Effects;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

procedure ShadowEffect(Form: TForm; Control: TControl;
  ShadowColor: TColor; ShadowWidth: Byte);
procedure ShadowEffectAll(Form: TForm; ShadowColor: TColor;
  ShadowWidth: Byte);
procedure InsetEffect(Form: TForm; Control: TControl;
  FrameWidth: Byte);
procedure InsetEffectAll(Form: TForm; FrameWidth: Byte);
procedure RaisedEffect(Form: TForm; Control: TControl;
  FrameWidth: Byte);
procedure RaisedEffectAll(Form: TForm; FrameWidth: Byte);

implementation

procedure ShadowEffect(Form: TForm; Control: TControl;
  ShadowColor: TColor; ShadowWidth: Byte);

var
  PenColor: TColor;
  I: Integer;

begin
  PenColor := Form.Canvas.Pen.Color;
  Form.Canvas.Pen.Color := ShadowColor;
  if ShadowWidth = 0 then
    ShadowWidth := 1;
  if ShadowWidth > 10 then
    ShadowWidth := 10;
  with Control do
    begin
      for I := 0 to ShadowWidth-1 do
        begin
          Form.Canvas.MoveTo(Left+Width+I, Top+ShadowWidth);
          Form.Canvas.LineTo(Left+Width+I, Top+Height+ShadowWidth);
        end;
      for I := 0 to ShadowWidth-1 do
        begin
          Form.Canvas.MoveTo(Left+ShadowWidth, Top+Height+I);
          Form.Canvas.LineTo(Left+Width+ShadowWidth, Top+Height+I);
        end;
    end;
  Form.Canvas.Pen.Color := PenColor;
end;

procedure ShadowEffectAll(Form: TForm; ShadowColor: TColor;
  ShadowWidth: Byte);

var
  I: Integer;

begin
  if Form.ComponentCount > 0 then
    begin
      for I := 0 to Form.ComponentCount-1 do
        ShadowEffect(Form, TControl(Form.Components[I]),
          ShadowColor, ShadowWidth);
    end;
end;

procedure InsetEffect(Form: TForm; Control: TControl;
  FrameWidth: Byte);

var
  PenColor: TColor;
  I: Integer;

begin
  PenColor := Form.Canvas.Pen.Color;
  if FrameWidth = 0 then
    FrameWidth := 1;
  if FrameWidth > 10 then
    FrameWidth := 10;
  with Control do
    begin
      Form.Canvas.Pen.Color := clBtnShadow;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left-I-1, Top-I-1);
          Form.Canvas.LineTo(Left-I-1, Top+Height+I+1);
        end;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left-I-1, Top-I-1);
          Form.Canvas.LineTo(Left+Width+I+1, Top-I-1);
        end;
      Form.Canvas.Pen.Color := clBtnHighlight;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left+Width+I, Top-I);
          Form.Canvas.LineTo(Left+Width+I, Top+Height+I);
        end;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left-I, Top+Height+I);
          Form.Canvas.LineTo(Left+Width+I+1, Top+Height+I);
        end;
    end;
  Form.Canvas.Pen.Color := PenColor;
end;

procedure InsetEffectAll(Form: TForm; FrameWidth: Byte);

var
  I: Integer;

begin
  if Form.ComponentCount > 0 then
    begin
      for I := 0 to Form.ComponentCount-1 do
        InsetEffect(Form, TControl(Form.Components[I]), FrameWidth);
    end;
end;

procedure RaisedEffect(Form: TForm; Control: TControl;
  FrameWidth: Byte);

var
  PenColor: TColor;
  I: Integer;

begin
  PenColor := Form.Canvas.Pen.Color;
  if FrameWidth = 0 then
    FrameWidth := 1;
  if FrameWidth > 10 then
    FrameWidth := 10;
  with Control do
    begin
      Form.Canvas.Pen.Color := clBtnHighlight;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left-I-1, Top-I-1);
          Form.Canvas.LineTo(Left-I-1, Top+Height+I+1);
        end;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left-I-1, Top-I-1);
          Form.Canvas.LineTo(Left+Width+I+1, Top-I-1);
        end;
      Form.Canvas.Pen.Color := clBtnShadow;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left+Width+I, Top-I);
          Form.Canvas.LineTo(Left+Width+I, Top+Height+I);
        end;
      for I := 0 to FrameWidth-1 do
        begin
          Form.Canvas.MoveTo(Left-I, Top+Height+I);
          Form.Canvas.LineTo(Left+Width+I+1, Top+Height+I);
        end;
    end;
  Form.Canvas.Pen.Color := PenColor;
end;

procedure RaisedEffectAll(Form: TForm; FrameWidth: Byte);

var
  I: Integer;

begin
  if Form.ComponentCount > 0 then
    begin
      for I := 0 to Form.ComponentCount-1 do
        RaisedEffect(Form, TControl(Form.Components[I]), FrameWidth);
    end;
end;

end.
