unit Pushbttn;

{ Composant TPushButton; TColorPushButton }

interface

uses Classes, ExtCtrls, Graphics ;

type TPushButton = class (TPanel)
  private
    FDown : Boolean ;
    FUpColor : TColor ;
    FDownColor : TColor ;
    procedure SetDown (value : Boolean);
    procedure SetUpColor  (UpColor : TColor) ;
    procedure SetDownColor (DownColor : TColor) ;
  public
    constructor Create (AOwner : TComponent) ; override ;
    procedure Click ; override;
  published
    property Down : Boolean
      read FDown  write SetDown default False ;
    property UpColor : TColor
      read FUpColor write SetUpColor default clSilver ;
    property DownColor : TColor
      read FDownColor write SetDownColor default clSilver ;
end ;

{***********************}

type TColorPushButton = class (TPushButton)
  public
    constructor Create (AOwner : TComponent) ; override ;
end ;

{** enregistrement ** }

procedure Register;

{*********************************************************************}
implementation

procedure TPushButton.SetDown (value : Boolean);
  begin
    if FDown<>Value then begin
      FDown := value ;
      if FDown then begin
        BevelOuter := bvLowered ;
        Color := FDownColor ;
      end else begin
        BevelOuter := bvRaised ;
        Color := FUpColor ;
      end ;
      Invalidate ;
    end ;
  end ;

procedure TPushButton.SetUpColor  (UpColor : TColor) ;
  begin
    if FUpColor <>UpColor then begin
      if not FDown then
        Color := FUpColor ;
      Invalidate ;
    end ;
  end ;

procedure TPushButton.SetDownColor (DownColor : TColor) ;
  begin
    if FDownColor <> DownColor then begin
      FDownColor := DownColor ;
      if FDown then
        Color := FDownColor ;
      Invalidate ;
    end ;
  end ;

constructor TPushButton.Create (AOwner : TComponent) ;
  begin
    inherited Create (AOwner) ;
    FDown := false ;
    BevelWidth := 2 ;
    FUpColor := clSilver ;
    FDownColor := clSilver ;
    Color := FUpColor ;
    Repaint ;
  end ;

procedure TPushButton.Click ;
  begin
    inherited Click ;
    if FDown then
      if BevelOuter = bvRaised then begin
        BevelOuter := bvLowered ;
        Color := FDownColor ;
      end else begin
        bevelOUter := bvRaised ;
        Color := FUpColor ;
        FDown := false ;
      end 
    else
      if BevelOUter = bvLowered then begin
        BevelOUter := bvRaised ;
        Color := FUPColor ;
      end else begin
        BevelOuter := bvLowered ;
        Color := FDownColor ;
        FDown := True ;
      end ;
    Repaint ;
  end ;

{********************************}

constructor TColorPushButton.Create (AOwner : TComponent) ;
  begin
    inherited Create (AOwner) ;
    FUpColor := clGreen ;
    FDownColor := clRed ;
    Color := FUpColor ;
    Repaint ;
  end ;



procedure Register;

begin
  { Recensement des nouveaux composants }
  RegisterComponents('Exemples', [TPushButton, TColorPushButton]);
end;


{***********************************************************}

begin
  { Recensement des nouvelles classes }
  RegisterClasses([TPushButton, TColorPushButton]);
end.

